# ASN.1 module DENM-PDU-Description
 OID: _{itu-t (0) identified-organization (4) etsi (0) itsDomain (5) wg1 (1) denmPduRelease2 (103831) major-version-2 (2) minor-version-1 (1)}_

## Imports:
 * **[ETSI-ITS-CDD](ETSI-ITS-CDD.md)** *{itu-t (0) identified-organization (4) etsi (0) itsDomain (5) wg1 (1) ts (102894) cdd (2) major-version-3 (3) minor-version-1 (1)}*<br/>
  
## Data Elements:
### <a name="DENM"></a>DENM

Fields:
* header of type [**ItsPduHeader**](ETSI-ITS-CDD.md#ItsPduHeader)  (WITH COMPONENTS {... , protocolVersion (2)<br>
* denm of type [**DenmPayload**](#DenmPayload) <br>
    messageId(denm)}),
```asn1
DENM ::= SEQUENCE {
	header ItsPduHeader (WITH COMPONENTS {... , protocolVersion (2), messageId(denm)}),
	denm   DenmPayload
}
```

### <a name="DenmPayload"></a>DenmPayload

Fields:
* management of type [**ManagementContainer**](#ManagementContainer) <br>
* situation of type [**SituationContainer**](#SituationContainer)  OPTIONAL<br>
   
* location of type [**LocationContainer**](#LocationContainer)  OPTIONAL<br>
   
* alacarte of type [**AlacarteContainer**](#AlacarteContainer)  OPTIONAL<br>
   
```asn1
DenmPayload ::= SEQUENCE {
	management ManagementContainer,
	situation  SituationContainer OPTIONAL,
	location   LocationContainer OPTIONAL,
	alacarte   AlacarteContainer OPTIONAL
}
```

### <a name="ManagementContainer"></a>ManagementContainer

Fields:
* actionId of type [**ActionId**](ETSI-ITS-CDD.md#ActionId) <br>
* detectionTime of type [**TimestampIts**](ETSI-ITS-CDD.md#TimestampIts) <br>
   
* referenceTime of type [**TimestampIts**](ETSI-ITS-CDD.md#TimestampIts) <br>
   
* termination of type [**Termination**](#Termination)  OPTIONAL<br>
   
* eventPosition of type [**ReferencePosition**](ETSI-ITS-CDD.md#ReferencePosition) <br>
   
* awarenessDistance of type [**StandardLength3b**](ETSI-ITS-CDD.md#StandardLength3b)  OPTIONAL<br>
   
* awarenessTrafficDirection of type [**TrafficDirection**](ETSI-ITS-CDD.md#TrafficDirection)  OPTIONAL<br>
   
* validityDuration of type [**DeltaTimeSecond**](ETSI-ITS-CDD.md#DeltaTimeSecond)  DEFAULT defaultValidity<br>
   
* transmissionInterval of type [**DeltaTimeMilliSecondPositive**](ETSI-ITS-CDD.md#DeltaTimeMilliSecondPositive)  OPTIONAL<br>
    
* stationType of type [**StationType**](ETSI-ITS-CDD.md#StationType) <br>
   
```asn1
ManagementContainer ::= SEQUENCE {
	actionId                  ActionId,
	detectionTime             TimestampIts,
	referenceTime             TimestampIts,
	termination               Termination OPTIONAL,
	eventPosition             ReferencePosition,
	awarenessDistance         StandardLength3b OPTIONAL,
	awarenessTrafficDirection TrafficDirection OPTIONAL,
	validityDuration          DeltaTimeSecond DEFAULT defaultValidity, 
	transmissionInterval      DeltaTimeMilliSecondPositive OPTIONAL,
	stationType               StationType,
	...
}
```

### <a name="SituationContainer"></a>SituationContainer

Fields:
* informationQuality of type [**InformationQuality**](ETSI-ITS-CDD.md#InformationQuality) <br>
* eventType of type [**CauseCodeV2**](ETSI-ITS-CDD.md#CauseCodeV2) <br>
   
* linkedCause of type [**CauseCodeV2**](ETSI-ITS-CDD.md#CauseCodeV2)  OPTIONAL<br>
   
* eventZone of type [**EventZone**](ETSI-ITS-CDD.md#EventZone)  OPTIONAL<br>
   
```asn1
SituationContainer ::= SEQUENCE {
	informationQuality InformationQuality,
	eventType          CauseCodeV2,
	linkedCause        CauseCodeV2 OPTIONAL,
	eventZone          EventZone OPTIONAL,
	...
}
```

### <a name="LocationContainer"></a>LocationContainer

Fields:
* eventSpeed of type [**Speed**](ETSI-ITS-CDD.md#Speed)  OPTIONAL<br>
* eventPositionHeading of type [**Wgs84Angle**](ETSI-ITS-CDD.md#Wgs84Angle)  OPTIONAL<br>
   
* traces of type [**Traces**](ETSI-ITS-CDD.md#Traces) <br>
   
* roadType of type [**RoadType**](ETSI-ITS-CDD.md#RoadType)  OPTIONAL<br>
   
```asn1
LocationContainer ::= SEQUENCE {
	eventSpeed           Speed OPTIONAL,
	eventPositionHeading Wgs84Angle OPTIONAL,
	traces               Traces,
	roadType             RoadType OPTIONAL,
	...
}
```

### <a name="ImpactReductionContainer"></a>ImpactReductionContainer

Fields:
* heightLonCarrLeft of type [**HeightLonCarr**](ETSI-ITS-CDD.md#HeightLonCarr) <br>
* heightLonCarrRight of type [**HeightLonCarr**](ETSI-ITS-CDD.md#HeightLonCarr) <br>
   
* posLonCarrLeft of type [**PosLonCarr**](ETSI-ITS-CDD.md#PosLonCarr) <br>
   
* posLonCarrRight of type [**PosLonCarr**](ETSI-ITS-CDD.md#PosLonCarr) <br>
   
* positionOfPillars of type [**PositionOfPillars**](ETSI-ITS-CDD.md#PositionOfPillars) <br>
   
* posCentMass of type [**PosCentMass**](ETSI-ITS-CDD.md#PosCentMass) <br>
   
* wheelBaseVehicle of type [**WheelBaseVehicle**](ETSI-ITS-CDD.md#WheelBaseVehicle) <br>
   
* turningRadius of type [**TurningRadius**](ETSI-ITS-CDD.md#TurningRadius) <br>
   
* posFrontAx of type [**PosFrontAx**](ETSI-ITS-CDD.md#PosFrontAx) <br>
   
* positionOfOccupants of type [**PositionOfOccupants**](ETSI-ITS-CDD.md#PositionOfOccupants) <br>
   
* vehicleMass of type [**VehicleMass**](ETSI-ITS-CDD.md#VehicleMass) <br>
   
* requestResponseIndication of type [**RequestResponseIndication**](ETSI-ITS-CDD.md#RequestResponseIndication) <br>
   
```asn1
ImpactReductionContainer ::= SEQUENCE {
	heightLonCarrLeft         HeightLonCarr,
	heightLonCarrRight        HeightLonCarr,
	posLonCarrLeft            PosLonCarr,
	posLonCarrRight           PosLonCarr,
	positionOfPillars         PositionOfPillars,
	posCentMass               PosCentMass,
	wheelBaseVehicle          WheelBaseVehicle,
	turningRadius             TurningRadius,
	posFrontAx                PosFrontAx,
	positionOfOccupants       PositionOfOccupants,
	vehicleMass               VehicleMass,
	requestResponseIndication RequestResponseIndication
}
```

### <a name="RoadWorksContainerExtended"></a>RoadWorksContainerExtended

Fields:
* lightBarSirenInUse of type [**LightBarSirenInUse**](ETSI-ITS-CDD.md#LightBarSirenInUse)  OPTIONAL<br>
* closedLanes of type [**ClosedLanes**](ETSI-ITS-CDD.md#ClosedLanes)  OPTIONAL<br>
   
* restriction of type [**RestrictedTypes**](ETSI-ITS-CDD.md#RestrictedTypes)  OPTIONAL<br>
   
* speedLimit of type [**SpeedLimit**](ETSI-ITS-CDD.md#SpeedLimit)  OPTIONAL<br>
   
* incidentIndication of type [**CauseCodeV2**](ETSI-ITS-CDD.md#CauseCodeV2)  OPTIONAL<br>
   
* recommendedPath of type [**ItineraryPath**](ETSI-ITS-CDD.md#ItineraryPath)  OPTIONAL<br>
   
* startingPointSpeedLimit of type [**DeltaReferencePosition**](ETSI-ITS-CDD.md#DeltaReferencePosition)  OPTIONAL<br>
   
* trafficFlowRule of type [**TrafficRule**](ETSI-ITS-CDD.md#TrafficRule)  OPTIONAL<br>
   
* referenceDenms of type [**ActionIdList**](ETSI-ITS-CDD.md#ActionIdList)  OPTIONAL<br>
   
```asn1
RoadWorksContainerExtended ::= SEQUENCE {
	lightBarSirenInUse      LightBarSirenInUse OPTIONAL,
	closedLanes             ClosedLanes OPTIONAL,
	restriction             RestrictedTypes OPTIONAL,
	speedLimit              SpeedLimit OPTIONAL,
	incidentIndication      CauseCodeV2 OPTIONAL,
	recommendedPath         ItineraryPath OPTIONAL,
	startingPointSpeedLimit DeltaReferencePosition OPTIONAL,
	trafficFlowRule         TrafficRule OPTIONAL,
	referenceDenms          ActionIdList OPTIONAL
 }
```

### <a name="StationaryVehicleContainer"></a>StationaryVehicleContainer

Fields:
* stationarySince of type [**StationarySince**](ETSI-ITS-CDD.md#StationarySince)  OPTIONAL<br>
* stationaryCause of type [**CauseCodeV2**](ETSI-ITS-CDD.md#CauseCodeV2)  OPTIONAL<br>
    
* carryingDangerousGoods of type [**DangerousGoodsExtended**](ETSI-ITS-CDD.md#DangerousGoodsExtended)  OPTIONAL<br>
   
* numberOfOccupants of type [**NumberOfOccupants**](ETSI-ITS-CDD.md#NumberOfOccupants)  OPTIONAL<br>
   
* vehicleIdentification of type [**VehicleIdentification**](ETSI-ITS-CDD.md#VehicleIdentification)  OPTIONAL<br>
   
* energyStorageType of type [**EnergyStorageType**](ETSI-ITS-CDD.md#EnergyStorageType)  OPTIONAL<br>
   
```asn1
StationaryVehicleContainer ::= SEQUENCE {
	stationarySince        StationarySince OPTIONAL, 
	stationaryCause        CauseCodeV2 OPTIONAL,
	carryingDangerousGoods DangerousGoodsExtended OPTIONAL,
	numberOfOccupants      NumberOfOccupants OPTIONAL,
	vehicleIdentification  VehicleIdentification OPTIONAL,
	energyStorageType      EnergyStorageType OPTIONAL
}
```

### <a name="AlacarteContainer"></a>AlacarteContainer

Fields:
* lanePosition of type [**LanePosition**](ETSI-ITS-CDD.md#LanePosition)  OPTIONAL<br>
* impactReduction of type [**ImpactReductionContainer**](#ImpactReductionContainer)  OPTIONAL<br>
   
* externalTemperature of type [**Temperature**](ETSI-ITS-CDD.md#Temperature)  OPTIONAL<br>
   
* roadWorks of type [**RoadWorksContainerExtended**](#RoadWorksContainerExtended)  OPTIONAL<br>
   
* positioningSolution of type [**PositioningSolutionType**](ETSI-ITS-CDD.md#PositioningSolutionType)  OPTIONAL<br>
   
* stationaryVehicle of type [**StationaryVehicleContainer**](#StationaryVehicleContainer)  OPTIONAL<br>
   
```asn1
AlacarteContainer ::= SEQUENCE {
	lanePosition        LanePosition OPTIONAL,
	impactReduction     ImpactReductionContainer OPTIONAL,
	externalTemperature Temperature OPTIONAL,
	roadWorks           RoadWorksContainerExtended OPTIONAL,
	positioningSolution PositioningSolutionType OPTIONAL,
	stationaryVehicle   StationaryVehicleContainer OPTIONAL,
	...
}
```

```asn1
defaultValidity INTEGER ::= 600
```


### <a name="Termination"></a>Termination
```asn1
Termination ::= ENUMERATED {isCancellation(0), isNegation (1)}
```



